'************************************
'* RC5 - Tester fr Fernbedienungen *
'* 07.09.2008                       *
'************************************
$regfile = "m8def.dat"                                      ' Controllerauswahl
$crystal = 4000000                                          'Quarzfrequenz
$baud = 9600                                                'Baudrate fr RS232-Schnittstelle                                          '

Config Lcdpin = Pin , Db4 = Portb.0 , Db5 = Portb.1 , Db6 = Portb.2 , Db7 = Portb.3 , E = Portb.4 , Rs = Portb.5       'Pins (Port B) fr LCD-Modul definieren

Config Lcd = 16 * 2                                         'LCD-Modul 2x16
Config Portb = Output
Deflcdchar 0 , 6 , 9 , 9 , 6 , 32 , 32 , 32 , 32            ' LCD-Sonderzeichen

'Pins von Port D definieren
Config Portd = Output                                       'PinD.4=LED4, PinD.5=LED3, PinD.6=LED2, PinD.7=LED1

'Pin von Port C definieren
Config Pinc.2 = Input                                       'PinC.2=IR-Empfnger

Config Rc5 = Pinc.2                                         'Eingangspin definieren
Enable Interrupts                                           'gibt Interrupts frei

'Variablen
Dim Adresse As Byte , Befehl As Byte

Cursor Off Noblink
Cls                                                         'LCD-Display lschen
Lcd "RC5-Testprogramm"                                      'Starttext

Do
  Config Pinc.2 = Input                                     'Pin 2 von Port C wird als Eingang definiert
  Getrc5(adresse , Befehl)                                  'empfngt die RC5 Daten

  If Adresse <> 255 Then                                    'wenn eine gltige Adresse empfangen wrde dann
      Befehl = Befehl And &B01111111                        'lscht das Toggle-Bit
      Cls                                                   'LCD-Display lschen

      If Adresse = 0 Then                                   'die TV-Gerteadresse ist 0
      Locate 1 , 1
      Lcd "Fernseher"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 5 Then                                   'die TV-Gerteadresse ist 5
      Locate 1 , 1
      Lcd "Videorecorder 1"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 6 Then                                   'die TV-Gerteadresse ist 6
      Locate 1 , 1
      Lcd "Videorecorder 2"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 8 Then                                   'die TV-Gerteadresse ist 8
      Locate 1 , 1
      Lcd "SAT-Receiver 1"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 9 Then                                   'die TV-Gerteadresse ist 9
      Locate 1 , 1
      Lcd "Videocamera"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 10 Then                                  'die TV-Gerteadresse ist 10
      Locate 1 , 1
      Lcd "SAT-Receiver 2"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 17 Then                                  'die TV-Gerteadresse ist 17
      Locate 1 , 1
      Lcd "Receiver / Tuner"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 18 Then                                  'die TV-Gerteadresse ist 18
      Locate 1 , 1
      Lcd "Tapedeck"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 20 Then                                  'die TV-Gerteadresse ist 20
      Locate 1 , 1
      Lcd "CD-Player"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

      If Adresse = 21 Then                                  'die TV-Gerteadresse ist 21
      Locate 1 , 1
      Lcd "Plattenspieler"
      Locate 2 , 1
      Lcd "Adr.:" ; Adresse ; "  Bef.:" ; Befehl            'empfangene Adresse und Befehl anzeigen
      End If

   End If

  Loop

End